<template>
  <mutate
    title="Đơn hàng thành viên mua"
    class="my-contributor-orders"
    :columns="columns"
    :data="orders"
    :options="mutateOptions"
    @update="updateOrder"
    @table-request="options => getOrders({ options, isReceiver: true })"
  >
    <template slot="detail" slot-scope="props">
      <div class="detail-order">
        <div class="text-h6 q-mb-md">Xem chi tiết đơn hàng #{{props.detail.id}}</div>
        <fragment v-for="(item, key) in props.detail" :key="key">
          <div v-if="TABLE_DETAIL_TEXT[key]" class="row justify-between order-item">
            <div class="title">{{key | table-detail}}</div>
            <div v-if="item" class="text-right">
              <span v-if="key === 'createdAt'">{{item | moment}}</span>
              <span
                v-else-if="key === 'status'"
              >{{item | order-status}}{{props.detail.isDeliverToCenter ? ' (đã gửi về trung tâm)' : ''}}</span>
              <span v-else-if="key === 'orderDetails'">
                <order-detail :order="props.detail" />
              </span>
              <span v-else-if="key === 'orderReceiver'">{{item.fullAddress}}</span>
              <span v-else>{{item}}</span>
            </div>
            <div v-else class="text-right text-italic">Không có dữ liệu</div>
          </div>
        </fragment>
      </div>
    </template>
    <template slot="mutation" slot-scope="props">
      <q-input v-model="props.data.shippingFee" outlined label="Phí vận chuyển" class="q-mb-md" />
    </template>
    <span slot="function" slot-scope="props">
      <fragment v-if="!props.row.isDeliverToCenter">
        <q-btn
          v-if="props.row.status !== 'COMPLETED'"
          flat
          dense
          icon="fas fa-shipping-fast"
          color="positive"
          class="q-mr-sm"
          @click="deliverToCenter(props.row.id)"
        >
          <q-tooltip anchor="top middle" self="bottom middle">Gửi đơn hàng về trung tâm</q-tooltip>
        </q-btn>
        <q-btn
          v-if="props.row.status === 'PENDING'"
          flat
          dense
          icon="thumb_up"
          color="positive"
          class="q-mr-sm"
          @click="approveOrder(props.row.id)"
        >
          <q-tooltip anchor="top middle" self="bottom middle">Xác nhận đơn hàng</q-tooltip>
        </q-btn>
        <q-btn
          v-if="props.row.status === 'APPROVED'"
          flat
          dense
          icon="move_to_inbox"
          color="primary"
          class="q-mr-sm"
          @click="deliverOrder(props.row.id)"
        >
          <q-tooltip anchor="top middle" self="bottom middle">Giao đơn hàng</q-tooltip>
        </q-btn>
        <q-btn
          v-if="['DELIVERING', 'REJECTED'].indexOf(props.row.status) > -1"
          flat
          dense
          icon="done"
          color="positive"
          class="q-mr-sm"
          @click="completeOrder(props.row.id)"
        >
          <q-tooltip anchor="top middle" self="bottom middle">Hoàn thành đơn hàng</q-tooltip>
        </q-btn>
        <q-btn
          v-if="props.row.status !== 'REJECTED'"
          flat
          dense
          icon="close"
          color="negative"
          class="q-mr-sm"
          @click="rejectOrder(props.row.id)"
        >
          <q-tooltip anchor="top middle" self="bottom middle">Huỷ đơn hàng</q-tooltip>
        </q-btn>
      </fragment>
    </span>
  </mutate>
</template>

<script>
import moment from 'moment';
import { mapActions, mapState, mapGetters } from 'vuex';
import {
  TABLE_DETAIL_TEXT,
  ORDER_STATUS_TEXT,
  ORDER_STATUS
} from '~/commons/enums';
import OrderDetail from '~/components/commons/OrderDetail.vue';
import Mutate from '~/components/commons/Mutate.vue';

export default {
  components: { Mutate, OrderDetail },
  meta() {
    return {
      title: 'Đơn hàng thành viên mua - Viet Distribution'
    };
  },
  data() {
    return {
      TABLE_DETAIL_TEXT,
      columns: [
        {
          name: 'id',
          label: 'Mã đơn hàng',
          align: 'left',
          field: 'id',
          sortable: true
        },
        {
          name: 'fullName',
          label: 'Tên người nhận',
          align: 'left',
          field: 'fullName',
          sortable: true
        },
        {
          name: 'phoneNumber',
          label: 'Số điện thoại',
          align: 'left',
          field: 'phoneNumber',
          sortable: true
        },
        {
          name: 'address',
          label: 'Địa chỉ giao hàng',
          align: 'left',
          field: 'orderReceiver',
          format: val => (val ? val.fullAddress : ''),
          sortable: true
        },
        {
          name: 'totalVat',
          label: 'Tổng tiền',
          align: 'left',
          field: 'totalVat',
          format: val => (val >= 0 ? `${val.toLocaleString()} VND` : ''),
          sortable: true
        },
        {
          name: 'totalBonusCommission',
          label: 'Tổng chiết khấu',
          align: 'left',
          field: 'totalBonusCommission',
          format: val => (val >= 0 ? `${val.toLocaleString()} VND` : ''),
          sortable: true
        },
        {
          name: 'totalEarning',
          label: 'Tổng TNCN',
          align: 'left',
          field: 'totalEarning',
          format: val => (val >= 0 ? `${val.toLocaleString()} VND` : ''),
          sortable: true
        },
        {
          name: 'shippingFee',
          label: 'Phí vận chuyển',
          align: 'left',
          field: 'shippingFee',
          format: val => (val > 0 ? `${val.toLocaleString()} VND` : 'Miễn phí'),
          sortable: true
        },
        {
          name: 'total',
          label: 'Tổng thanh toán',
          align: 'left',
          field: 'total',
          format: val => (val >= 0 ? `${val.toLocaleString()} VND` : ''),
          sortable: true
        },
        {
          name: 'note',
          label: 'Ghi chú',
          align: 'left',
          field: 'note',
          sortable: true
        },
        {
          name: 'status',
          label: 'Trạng thái',
          align: 'left',
          field: 'status',
          format: (val, row) =>
            `${ORDER_STATUS_TEXT[val]}${
              row.isDeliverToCenter ? ' (đã gửi về trung tâm)' : ''
            }`,
          sortable: true
        },
        {
          name: 'createdAt',
          label: 'Ngày tạo',
          align: 'left',
          field: 'createdAt',
          format: val => moment(val).format('DD/MM/YYYY HH:mm:ss'),
          sortable: true
        },
        {
          name: 'function',
          align: 'right'
        }
      ]
    };
  },
  computed: {
    ...mapState({
      authUser: state => state.auth.user,
      totalRows: state => state.orders.totalOrders
    }),
    ...mapGetters({
      orders: 'orders/getContributorOrders'
    }),
    mutateOptions() {
      return {
        totalRows: this.totalRows
      };
    }
  },
  mounted() {
    if (
      ['CONTRIBUTOR', 'CONTRIBUTOR_EDUCATED'].indexOf(
        this.authUser.userRetail
      ) > -1
    ) {
      window.location.href = '/';
    }
    this.getOrders({ isReceiver: true });
  },
  methods: {
    ...mapActions({
      getOrders: 'orders/getOrders',
      updateOrder: 'orders/updateOrder',
      deliverToCenter: 'orders/deliverToCenter'
    }),
    approveOrder(id) {
      this.updateOrder({ id, status: ORDER_STATUS.APPROVED });
    },
    deliverOrder(id) {
      this.updateOrder({ id, status: ORDER_STATUS.DELIVERING });
    },
    completeOrder(id) {
      this.updateOrder({ id, status: ORDER_STATUS.COMPLETED });
    },
    rejectOrder(id) {
      this.updateOrder({ id, status: ORDER_STATUS.REJECTED });
    }
  }
};
</script>

<style lang="scss" scoped>
.my-contributor-orders {
  padding: 0;
}
.detail-order {
  .order-item {
    padding: 10px;

    &:nth-child(even) {
      background-color: rgba(0, 0, 0, 0.1);
    }

    .title {
      font-weight: bold;
    }
  }
}
</style>
